'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _commonjsHelpers = require('./_commonjsHelpers.cjs');
var binary_hamming_distance$2 = require('./binary_hamming_distance2.cjs');
require('./_util.cjs');
require('./_path.cjs');
require('./_fs.cjs');
var require$$0 = require('util');
var require$$1 = require('path');
var require$$2 = require('fs');

var binary_hamming_distance = binary_hamming_distance$2.__module.exports;

(function (module) {
	let imports = {};
	imports['__wbindgen_placeholder__'] = module.exports;
	let wasm;
	const { TextDecoder, TextEncoder } = require$$0;

	let cachedTextDecoder = new TextDecoder('utf-8', { ignoreBOM: true, fatal: true });

	cachedTextDecoder.decode();

	let cachedUint8Memory0 = null;

	function getUint8Memory0() {
	    if (cachedUint8Memory0 === null || cachedUint8Memory0.byteLength === 0) {
	        cachedUint8Memory0 = new Uint8Array(wasm.memory.buffer);
	    }
	    return cachedUint8Memory0;
	}

	function getStringFromWasm0(ptr, len) {
	    return cachedTextDecoder.decode(getUint8Memory0().subarray(ptr, ptr + len));
	}

	const heap = new Array(128).fill(undefined);

	heap.push(undefined, null, true, false);

	let heap_next = heap.length;

	function addHeapObject(obj) {
	    if (heap_next === heap.length) heap.push(heap.length + 1);
	    const idx = heap_next;
	    heap_next = heap[idx];

	    heap[idx] = obj;
	    return idx;
	}

	function getObject(idx) { return heap[idx]; }

	let WASM_VECTOR_LEN = 0;

	let cachedTextEncoder = new TextEncoder('utf-8');

	const encodeString = (typeof cachedTextEncoder.encodeInto === 'function'
	    ? function (arg, view) {
	    return cachedTextEncoder.encodeInto(arg, view);
	}
	    : function (arg, view) {
	    const buf = cachedTextEncoder.encode(arg);
	    view.set(buf);
	    return {
	        read: arg.length,
	        written: buf.length
	    };
	});

	function passStringToWasm0(arg, malloc, realloc) {

	    if (realloc === undefined) {
	        const buf = cachedTextEncoder.encode(arg);
	        const ptr = malloc(buf.length);
	        getUint8Memory0().subarray(ptr, ptr + buf.length).set(buf);
	        WASM_VECTOR_LEN = buf.length;
	        return ptr;
	    }

	    let len = arg.length;
	    let ptr = malloc(len);

	    const mem = getUint8Memory0();

	    let offset = 0;

	    for (; offset < len; offset++) {
	        const code = arg.charCodeAt(offset);
	        if (code > 0x7F) break;
	        mem[ptr + offset] = code;
	    }

	    if (offset !== len) {
	        if (offset !== 0) {
	            arg = arg.slice(offset);
	        }
	        ptr = realloc(ptr, len, len = offset + arg.length * 3);
	        const view = getUint8Memory0().subarray(ptr + offset, ptr + len);
	        const ret = encodeString(arg, view);

	        offset += ret.written;
	    }

	    WASM_VECTOR_LEN = offset;
	    return ptr;
	}

	function isLikeNone(x) {
	    return x === undefined || x === null;
	}

	let cachedInt32Memory0 = null;

	function getInt32Memory0() {
	    if (cachedInt32Memory0 === null || cachedInt32Memory0.byteLength === 0) {
	        cachedInt32Memory0 = new Int32Array(wasm.memory.buffer);
	    }
	    return cachedInt32Memory0;
	}

	function dropObject(idx) {
	    if (idx < 132) return;
	    heap[idx] = heap_next;
	    heap_next = idx;
	}

	function takeObject(idx) {
	    const ret = getObject(idx);
	    dropObject(idx);
	    return ret;
	}

	let cachedFloat64Memory0 = null;

	function getFloat64Memory0() {
	    if (cachedFloat64Memory0 === null || cachedFloat64Memory0.byteLength === 0) {
	        cachedFloat64Memory0 = new Float64Array(wasm.memory.buffer);
	    }
	    return cachedFloat64Memory0;
	}

	function debugString(val) {
	    // primitive types
	    const type = typeof val;
	    if (type == 'number' || type == 'boolean' || val == null) {
	        return  `${val}`;
	    }
	    if (type == 'string') {
	        return `"${val}"`;
	    }
	    if (type == 'symbol') {
	        const description = val.description;
	        if (description == null) {
	            return 'Symbol';
	        } else {
	            return `Symbol(${description})`;
	        }
	    }
	    if (type == 'function') {
	        const name = val.name;
	        if (typeof name == 'string' && name.length > 0) {
	            return `Function(${name})`;
	        } else {
	            return 'Function';
	        }
	    }
	    // objects
	    if (Array.isArray(val)) {
	        const length = val.length;
	        let debug = '[';
	        if (length > 0) {
	            debug += debugString(val[0]);
	        }
	        for(let i = 1; i < length; i++) {
	            debug += ', ' + debugString(val[i]);
	        }
	        debug += ']';
	        return debug;
	    }
	    // Test for built-in
	    const builtInMatches = /\[object ([^\]]+)\]/.exec(toString.call(val));
	    let className;
	    if (builtInMatches.length > 1) {
	        className = builtInMatches[1];
	    } else {
	        // Failed to match the standard '[object ClassName]'
	        return toString.call(val);
	    }
	    if (className == 'Object') {
	        // we're a user defined class or Object
	        // JSON.stringify avoids problems with cycles, and is generally much
	        // easier than looping through ownProperties of `val`.
	        try {
	            return 'Object(' + JSON.stringify(val) + ')';
	        } catch (_) {
	            return 'Object';
	        }
	    }
	    // errors
	    if (val instanceof Error) {
	        return `${val.name}: ${val.message}\n${val.stack}`;
	    }
	    // TODO we could test for more things here, like `Set`s and `Map`s.
	    return className;
	}
	/**
	* @param {string} a
	* @param {string} b
	* @returns {number}
	*/
	module.exports.binary_hamming_distance = function(a, b) {
	    const ptr0 = passStringToWasm0(a, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
	    const len0 = WASM_VECTOR_LEN;
	    const ptr1 = passStringToWasm0(b, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
	    const len1 = WASM_VECTOR_LEN;
	    const ret = wasm.binary_hamming_distance(ptr0, len0, ptr1, len1);
	    return ret >>> 0;
	};

	let stack_pointer = 128;

	function addBorrowedObject(obj) {
	    if (stack_pointer == 1) throw new Error('out of js stack');
	    heap[--stack_pointer] = obj;
	    return stack_pointer;
	}
	/**
	* @param {any} assets
	* @returns {any}
	*/
	module.exports.calculate_hamming_distances = function(assets) {
	    try {
	        const retptr = wasm.__wbindgen_add_to_stack_pointer(-16);
	        wasm.calculate_hamming_distances(retptr, addBorrowedObject(assets));
	        var r0 = getInt32Memory0()[retptr / 4 + 0];
	        var r1 = getInt32Memory0()[retptr / 4 + 1];
	        var r2 = getInt32Memory0()[retptr / 4 + 2];
	        if (r2) {
	            throw takeObject(r1);
	        }
	        return takeObject(r0);
	    } finally {
	        wasm.__wbindgen_add_to_stack_pointer(16);
	        heap[stack_pointer++] = undefined;
	    }
	};

	function handleError(f, args) {
	    try {
	        return f.apply(this, args);
	    } catch (e) {
	        wasm.__wbindgen_exn_store(addHeapObject(e));
	    }
	}

	module.exports.__wbindgen_string_new = function(arg0, arg1) {
	    const ret = getStringFromWasm0(arg0, arg1);
	    return addHeapObject(ret);
	};

	module.exports.__wbindgen_string_get = function(arg0, arg1) {
	    const obj = getObject(arg1);
	    const ret = typeof(obj) === 'string' ? obj : undefined;
	    var ptr0 = isLikeNone(ret) ? 0 : passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
	    var len0 = WASM_VECTOR_LEN;
	    getInt32Memory0()[arg0 / 4 + 1] = len0;
	    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
	};

	module.exports.__wbindgen_object_drop_ref = function(arg0) {
	    takeObject(arg0);
	};

	module.exports.__wbindgen_is_object = function(arg0) {
	    const val = getObject(arg0);
	    const ret = typeof(val) === 'object' && val !== null;
	    return ret;
	};

	module.exports.__wbindgen_is_undefined = function(arg0) {
	    const ret = getObject(arg0) === undefined;
	    return ret;
	};

	module.exports.__wbindgen_in = function(arg0, arg1) {
	    const ret = getObject(arg0) in getObject(arg1);
	    return ret;
	};

	module.exports.__wbindgen_is_string = function(arg0) {
	    const ret = typeof(getObject(arg0)) === 'string';
	    return ret;
	};

	module.exports.__wbindgen_object_clone_ref = function(arg0) {
	    const ret = getObject(arg0);
	    return addHeapObject(ret);
	};

	module.exports.__wbindgen_error_new = function(arg0, arg1) {
	    const ret = new Error(getStringFromWasm0(arg0, arg1));
	    return addHeapObject(ret);
	};

	module.exports.__wbindgen_number_new = function(arg0) {
	    const ret = arg0;
	    return addHeapObject(ret);
	};

	module.exports.__wbindgen_jsval_loose_eq = function(arg0, arg1) {
	    const ret = getObject(arg0) == getObject(arg1);
	    return ret;
	};

	module.exports.__wbindgen_boolean_get = function(arg0) {
	    const v = getObject(arg0);
	    const ret = typeof(v) === 'boolean' ? (v ? 1 : 0) : 2;
	    return ret;
	};

	module.exports.__wbindgen_number_get = function(arg0, arg1) {
	    const obj = getObject(arg1);
	    const ret = typeof(obj) === 'number' ? obj : undefined;
	    getFloat64Memory0()[arg0 / 8 + 1] = isLikeNone(ret) ? 0 : ret;
	    getInt32Memory0()[arg0 / 4 + 0] = !isLikeNone(ret);
	};

	module.exports.__wbg_String_88810dfeb4021902 = function(arg0, arg1) {
	    const ret = String(getObject(arg1));
	    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
	    const len0 = WASM_VECTOR_LEN;
	    getInt32Memory0()[arg0 / 4 + 1] = len0;
	    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
	};

	module.exports.__wbg_getwithrefkey_5e6d9547403deab8 = function(arg0, arg1) {
	    const ret = getObject(arg0)[getObject(arg1)];
	    return addHeapObject(ret);
	};

	module.exports.__wbg_set_841ac57cff3d672b = function(arg0, arg1, arg2) {
	    getObject(arg0)[takeObject(arg1)] = takeObject(arg2);
	};

	module.exports.__wbg_get_27fe3dac1c4d0224 = function(arg0, arg1) {
	    const ret = getObject(arg0)[arg1 >>> 0];
	    return addHeapObject(ret);
	};

	module.exports.__wbg_length_e498fbc24f9c1d4f = function(arg0) {
	    const ret = getObject(arg0).length;
	    return ret;
	};

	module.exports.__wbg_new_b525de17f44a8943 = function() {
	    const ret = new Array();
	    return addHeapObject(ret);
	};

	module.exports.__wbindgen_is_function = function(arg0) {
	    const ret = typeof(getObject(arg0)) === 'function';
	    return ret;
	};

	module.exports.__wbg_new_f841cc6f2098f4b5 = function() {
	    const ret = new Map();
	    return addHeapObject(ret);
	};

	module.exports.__wbg_next_b7d530c04fd8b217 = function(arg0) {
	    const ret = getObject(arg0).next;
	    return addHeapObject(ret);
	};

	module.exports.__wbg_next_88560ec06a094dea = function() { return handleError(function (arg0) {
	    const ret = getObject(arg0).next();
	    return addHeapObject(ret);
	}, arguments) };

	module.exports.__wbg_done_1ebec03bbd919843 = function(arg0) {
	    const ret = getObject(arg0).done;
	    return ret;
	};

	module.exports.__wbg_value_6ac8da5cc5b3efda = function(arg0) {
	    const ret = getObject(arg0).value;
	    return addHeapObject(ret);
	};

	module.exports.__wbg_iterator_55f114446221aa5a = function() {
	    const ret = Symbol.iterator;
	    return addHeapObject(ret);
	};

	module.exports.__wbg_get_baf4855f9a986186 = function() { return handleError(function (arg0, arg1) {
	    const ret = Reflect.get(getObject(arg0), getObject(arg1));
	    return addHeapObject(ret);
	}, arguments) };

	module.exports.__wbg_call_95d1ea488d03e4e8 = function() { return handleError(function (arg0, arg1) {
	    const ret = getObject(arg0).call(getObject(arg1));
	    return addHeapObject(ret);
	}, arguments) };

	module.exports.__wbg_new_f9876326328f45ed = function() {
	    const ret = new Object();
	    return addHeapObject(ret);
	};

	module.exports.__wbg_set_17224bc548dd1d7b = function(arg0, arg1, arg2) {
	    getObject(arg0)[arg1 >>> 0] = takeObject(arg2);
	};

	module.exports.__wbg_isArray_39d28997bf6b96b4 = function(arg0) {
	    const ret = Array.isArray(getObject(arg0));
	    return ret;
	};

	module.exports.__wbg_instanceof_ArrayBuffer_a69f02ee4c4f5065 = function(arg0) {
	    let result;
	    try {
	        result = getObject(arg0) instanceof ArrayBuffer;
	    } catch {
	        result = false;
	    }
	    const ret = result;
	    return ret;
	};

	module.exports.__wbg_set_388c4c6422704173 = function(arg0, arg1, arg2) {
	    const ret = getObject(arg0).set(getObject(arg1), getObject(arg2));
	    return addHeapObject(ret);
	};

	module.exports.__wbg_isSafeInteger_8c4789029e885159 = function(arg0) {
	    const ret = Number.isSafeInteger(getObject(arg0));
	    return ret;
	};

	module.exports.__wbg_buffer_cf65c07de34b9a08 = function(arg0) {
	    const ret = getObject(arg0).buffer;
	    return addHeapObject(ret);
	};

	module.exports.__wbg_new_537b7341ce90bb31 = function(arg0) {
	    const ret = new Uint8Array(getObject(arg0));
	    return addHeapObject(ret);
	};

	module.exports.__wbg_set_17499e8aa4003ebd = function(arg0, arg1, arg2) {
	    getObject(arg0).set(getObject(arg1), arg2 >>> 0);
	};

	module.exports.__wbg_length_27a2afe8ab42b09f = function(arg0) {
	    const ret = getObject(arg0).length;
	    return ret;
	};

	module.exports.__wbg_instanceof_Uint8Array_01cebe79ca606cca = function(arg0) {
	    let result;
	    try {
	        result = getObject(arg0) instanceof Uint8Array;
	    } catch {
	        result = false;
	    }
	    const ret = result;
	    return ret;
	};

	module.exports.__wbindgen_debug_string = function(arg0, arg1) {
	    const ret = debugString(getObject(arg1));
	    const ptr0 = passStringToWasm0(ret, wasm.__wbindgen_malloc, wasm.__wbindgen_realloc);
	    const len0 = WASM_VECTOR_LEN;
	    getInt32Memory0()[arg0 / 4 + 1] = len0;
	    getInt32Memory0()[arg0 / 4 + 0] = ptr0;
	};

	module.exports.__wbindgen_throw = function(arg0, arg1) {
	    throw new Error(getStringFromWasm0(arg0, arg1));
	};

	module.exports.__wbindgen_memory = function() {
	    const ret = wasm.memory;
	    return addHeapObject(ret);
	};

	const path = require$$1.join(__dirname, 'binary_hamming_distance_bg.wasm');
	const bytes = require$$2.readFileSync(path);

	const wasmModule = new WebAssembly.Module(bytes);
	const wasmInstance = new WebAssembly.Instance(wasmModule, imports);
	wasm = wasmInstance.exports;
	module.exports.__wasm = wasm; 
} (binary_hamming_distance$2.__module));

var binary_hamming_distanceExports = binary_hamming_distance$2.__module.exports;
var binary_hamming_distance$1 = /*@__PURE__*/_commonjsHelpers.getDefaultExportFromCjs(binary_hamming_distanceExports);

exports.binary_hamming_distanceExports = binary_hamming_distanceExports;
exports.default = binary_hamming_distance$1;
//# sourceMappingURL=binary_hamming_distance.cjs.map
