export declare const bitCount: (n: number) => number;
export declare const bigIntBitCount: (n: bigint) => number;
/**
 * Hamming distance between two strings or numbers
 * @param a - first string or number e.g. '123456'
 * @param b - second string or number e.g. '654321'
 */
export declare const decimalHammingDistance: (a: string | number, b: string | number) => number;
export declare const bigIntHammingDistance: (a: bigint, b: bigint) => number;
/**
 * Hamming distance between two binary strings
 * @param a - first string e.g. '101010'
 * @param b - second string e.g. '010101'
 */
export declare const binaryHammingDistance: (a: string, b: string) => number;
/**
 * Hamming distance between two binary strings
 * @param a - first string e.g. '101010'
 * @param b - second string e.g. '010101'
 */
export declare const binaryStringHammingDistance: (a: string, b: string) => number;
export declare const wasmBinaryStringHammingDistance: (a: string, b: string) => number;
